/*                      LEKCJA02.C
//---------------------------------------------------------------------------
Temat:
        Komunikacja z uytkownikiem poprzez okna dialogowe
//---------------------------------------------------------------------------
Funkcje:
        EXT(207) short Message(        
        EXT(208) void MouseHelp(       
        EXT(211) void SetFuncText(     
        EXT(224) short StringInput(   
        EXT(203) short DlgInput(       
        HLP_INV(f,b,s)
//---------------------------------------------------------------------------

EXT(207) short Message(        // 
             char  *str1,      // 1. linia tekstu (max. 40 znakw)
             char  *str2,      // 2. linia tekstu
             char  *but1,      // 1. klawisz (moe mie warto NULL)
             char  *but2,      // 2. klawisz (moe mie warto NULL)
             char  *but3,      // 3. klawisz (max. 9 znakw)
             short defbut);    // standard-klawisz (1-3)

Opis:
    Funkcja przedstawia na ekranie dwie linie tekstu (str1, str2) 
    dugoci od 0 do 40 znakw oraz trzy klawisze o nazwach tekstowych 
    (but1, but2, but3) zawierajcych od 0 do 9 znakw.
    Jeli klawisz (but1 i/lub but2) ma warto NULL to jest on niewidoczny.
    Klawisz but3 nie moe mie wartoci NULL !
    Parametr defbut zawiera numer klawisza uznanego za standardowy, ktry
    bdzie wskazywany kursorem po wywoaniu funkcji.

Return:
    0  => jeli wybrany punkt ley poza oknem dialogowym
    n  => numer wybranego klawisza (but1= 1, but2= 2, but3= 3)

Przykad:
    Message("Przykad demonstrujcy funkcj 'Message'",
            "Uytkownik wybiera jedn z 4 moliwoci.",
            "klawisz-1","klawisz-2","klawisz-3",3);
//---------------------------------------------------------------------------

EXT(208) void MouseHelp(       // 
             char   *str1,     // opis znaczenia lewego klawisza (max. 13)
             char   *str2,     // opis znaczenia prawego klawisza
             ushort inv);      // kolor tekstu i ta (HLP_INV)

Opis:
    Tekst informacyjny wpisywany w dolnej czci ekranu przedstawiajcy 
    znaczenie klawiszy myszy o dugoci do 13 znakw. 
    Parametr inv definiuje kolor tekstu i ta zmiennej tekstowej definiujcej
    pole przeznaczone do opisu dziaania lewego klawisza. Aby uatwi
    jego przeliczenie przygotowano makro HLP_INV.

HLP_INV(f,b,s)
    f = kolor tekstu, b = kolor ta, s = dzwik ?
    Jeli obydwie wartoci (f, b) s rwne 0 przyjmowany jest kolor 
    standardowy.
    Jeli parametr s=1 zostanie wydany sygna dzwikowy.

Przykad:
    MouseHelp("lewy klawisz","prawy klawisz",HLP_INV(1,10,1));  
//---------------------------------------------------------------------------

EXT(211) void SetFuncText(     // 
             char *text);      // wywietlany tekst (max. 27 znakw)

Opis:
    Tekst informacyjny podajcy nazw aktualnie wykonywanej funkcji
    o dugoci do 27 znakw.

Patrz te:
    MouseHelp

Przykad:
    SetFuncText("pokaz wartoci numerycznych");           
//---------------------------------------------------------------------------

EXT(224) short StringInput(   // 
            char   *title,    // tekst informacyjny (max. 49 znakw)
            char   *buf,      // bufor do edycji tekstu (max. 255 znakw) 
            ushort buflen);   // wielko bufora

Opis:
    Pozwala uytkownikowi wpisa lini tekstu do bufora o dugoci buflen.
    Title jest tekstem informacyjnym maksymalnej dugoci 49 znakw
    ukazujcym si w oknie dialogowym i "podpowiadajcym" uytkownikowi 
    co ma robi.

Patrz te:
    DlgInput

Return:
    TRUE  => przy potwierdzeniu "ok"
    FALSE => po wybraniu klawisza "powrt"

Przykad:
    StringInput("Wpisz rzdany tekst !",tekst,255); 
//---------------------------------------------------------------------------

EXT(203) short DlgInput(       // 
             ushort   num,     // ilo pl (1 - 10)
             char     *title,  // tytu pola dialogowego (max. 21 znakw)
             t_dlgdta *dta);   // tablica z opisem pl

Opis:
    Zdefiniowanie zmiennych numerycznych. 
    Pozwala uytkownikowi poda wartoci zmiennym i/lub wybra opcj
    dziaania funkcji.

    Sposb zdefiniowania tablicy pl:

        typedef struct _dlgdta
        {
           char     text[11];    // nazwa klawisza (max. 9 znakw)
           uchar    type;        // typ pola
           void     _far *val;   // adres zmiennej lub NULL dla klawisza
        } t_dlgdta;              

    Typy zmiennych, jakie mog wystpowa w tablicy:

    DLG_SHT : short integer 
    DLG_LNG : long integer 
    DLG_PHI : double - warto kta podana przez uytkownika w stopniach
              zostaje zamieniona dla interpretera na radiany.
    DLG_LEN : double - dugo lub koordynaty podane przez uytkownika
              w aktualnie uywanej jednostce zostaj zamienione dla 
              interpretera na milimetry.
    DLG_FAC : double - faktor numeryczny
    DLG_BUT : klawisz z napisem tekstowym do wyboru opcji.

Return:
    0   => po wybraniu klawisza "powrt"
    1   => przy potwierdzeniu "ok"
    n   => numer klawisza z opcj (o ile istnieje)

Przykad:
    DlgInput(4,"ustalenie zmiennych",&dlg[0])

*/
//---------------------------------------------------------------------------
//      Andrzej Setman                                  Wiede 5-6.08.1995                             
//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
//---------------------------------------------------------------------------
short main(char *filename, char *args)
{
   t_dlgdta    dlg[5];

   char        tekst[255], kette[42];
   short       butret,  klawisz= 1;
   short       sht= 100;
   long        lng= 123456789;
   double      phi= (DEF_PI/4);
   double      len= 100;
   double      fac= 100;

   while  (klawisz != 0)
   {
      dlg[0].type= dlg[1].type= dlg[2].type= dlg[3].type= DLG_BUT;
      dlg[0].val = dlg[1].val = dlg[2].val = dlg[3].val = NULL;
      strcpy(dlg[0].text,"Message");
      strcpy(dlg[1].text,"DlgInput");
      strcpy(dlg[2].text,"MouseHelp");
      strcpy(dlg[3].text,"StringInpu");

      SetFuncText("Wybierz waciwy klawisz ! ");           

      klawisz= DlgInput(4,"funkcje dialogowe",&dlg[0]);      

      switch(klawisz)
      {
      case 1:                           // demonstracja funkcji Message

         SetFuncText("uycie funkcji Message");           
         butret = Message("Przykad demonstrujcy funkcj 'Message'",
                          "Uytkownik wybiera jedn z 4 moliwoci.",
                          "klawisz-1","klawisz-2","klawisz-3",3);
         switch(butret)    
         {
         case 1:
                    Message("Przykad demonstrujcy funkcj 'Message'",
                    "wybrano: 'klawisz-1'",
                    NULL,NULL,"ok",3);
                    break;
         case 2:
                    Message("Przykad demonstrujcy funkcj 'Message'",
                    "wybrano: 'klawisz-2'",
                    NULL,NULL,"ok",3);
                    break;
         case 3:
                    Message("Przykad demonstrujcy funkcj 'Message'",
                    "wybrano: 'klawisz-3'",
                    NULL,NULL,"ok",3);
                    break;
         default:
                    Message("Przykad demonstrujcy funkcj 'Message'",
                    "Wskazano punkt poza oknem dialogowym !",
                    NULL,NULL,"ok",3);
                    break;
         }
         break;
         //------------------------------------------------------------------

      case 2:                           // demonstracja funkcji DlgInput

         dlg[0].type= DLG_SHT;
         dlg[1].type= DLG_LNG;
         dlg[2].type= DLG_FAC;
         dlg[3].type= DLG_PHI;
         dlg[4].type= DLG_FAC;
         dlg[0].val= &sht;
         dlg[1].val= &lng;
         dlg[2].val= &fac;
         dlg[3].val= &phi;
         dlg[4].val= &len;
         strcpy(dlg[0].text,"int short ");
         strcpy(dlg[1].text,"int long  ");
         strcpy(dlg[2].text,"double    ");
         strcpy(dlg[3].text,"kt       ");
         strcpy(dlg[4].text,"odstp    ");
         
         SetFuncText("pokaz wartoci numerycznych");           
         butret= DlgInput(5,"--wpisanie wartosci--",&dlg[0]); 

         if (butret==0) break;

         sprintf(kette,"sht= %d   lng= %d ", sht, lng);
         Message("zmienne typu 'short int' i 'long int'",
                  kette,NULL,NULL,"ok",3);

         sprintf(kette,"stopnie= %f  radiany= %f ", phi/DEF_PI*180l, phi);
         Message("warto kta w stopniach i w radianach",
                  kette,NULL,NULL,"ok",3);
         sprintf(kette,"dugo= %f  faktor= %f ", len, fac);
         Message("dugo w 'mm' i faktor niemianowany",
                  kette,NULL,NULL,"ok",3);
         break;
         //------------------------------------------------------------------

      case 3:                           // demonstracja funkcji MouseHelp

         SetFuncText("uycie funkcji MouseHelp");           // nazwa funkcji
         MouseHelp("lewy klawisz","prawy klawisz",HLP_INV(1,10,1));  
         Message("","",NULL,NULL,"",3);
         MouseHelp("","",0);
         break;
         //------------------------------------------------------------------

      case 4:                           // demonstracja funkcji StringInput

         SetFuncText("uycie funkcji StringInput");           
         StringInput("Przypisanie zmiennej tekstowej dowolnego tekstu !",
                      tekst,255);  
         if(strlen(tekst) <= 40)
         {
            Message(" Aktualna zawarto zmiennej tekstowej: ",
                     tekst,NULL,NULL,"ok",3);
         }
         else
         {
            Message("Tekst jest zbyt dugi, by przedstawi go",
                    "przy uyciu funkcji 'Message' !",NULL,NULL,"ok",3);
         }
         break;
         //------------------------------------------------------------------

      default:                          //  'klawisz' = 0

         Message("Koniec demonstracji - wybrano 'powrt'",
                 " lub wskazano poza oknem dialogowym !",
                   NULL,NULL,"ok",3);
         break;
      }
   }
return(0);
}
//---------------------------------------------------------------------------
